// This file is generated by kconfig_compiler from kalarmconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef PREFERENCESBASE_H
#define PREFERENCESBASE_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <qfont.h>
#include <qcolor.h>
#include <qnamespace.h>
#include <kglobalsettings.h>
#include <kamail.h>
#include <timeperiod.h>
class PreferencesBase : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum MailClient { sendmail, kmail };
    enum SoundType { Sound_None, Sound_Beep, Sound_File, Sound_Speak };
    enum CmdLogType { Log_Discard, Log_File, Log_Terminal };
    enum RecurType { Recur_None, Recur_Login, Recur_SubDaily, Recur_Daily, Recur_Weekly, Recur_Monthly, Recur_Yearly };
    enum Feb29Type { Feb29_Feb28, Feb29_Mar1, Feb29_None };

    enum { signalRunInSystemTrayChanged, signalDisableAlarmsIfStoppedChanged, signalBase_StartOfDayChanged, signalShowTimeChanged, signalDaemonTrayCheckIntervalChanged, signalDisabledColourChanged, signalArchivedColourChanged, signalArchivedKeepDaysChanged, signalFeb29TypeChanged };

    static PreferencesBase *self();
    ~PreferencesBase();

    /**
      Set KAlarm version
    */
    static
    void setVersion( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Version" ) ))
        self()->mVersion = v;
    }

    /**
      Get KAlarm version
    */
    static
    QString version()
    {
      return self()->mVersion;
    }

    /**
      Get Item object corresponding to Version()
    */
    ItemString *versionItem()
    {
      return mVersionItem;
    }

    /**
      Set Time zone
    */
    static
    void setBase_TimeZone( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_TimeZone" ) ))
        self()->mBase_TimeZone = v;
    }

    /**
      Get Time zone
    */
    static
    QString base_TimeZone()
    {
      return self()->mBase_TimeZone;
    }

    /**
      Get Item object corresponding to Base_TimeZone()
    */
    ItemString *base_TimeZoneItem()
    {
      return mBase_TimeZoneItem;
    }

    /**
      Set Color selection list
    */
    static
    void setBase_MessageColours( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_MessageColours" ) ))
        self()->mBase_MessageColours = v;
    }

    /**
      Get Color selection list
    */
    static
    QStringList base_MessageColours()
    {
      return self()->mBase_MessageColours;
    }

    /**
      Get Item object corresponding to Base_MessageColours()
    */
    ItemStringList *base_MessageColoursItem()
    {
      return mBase_MessageColoursItem;
    }

    /**
      Set Background color
    */
    static
    void setDefaultBgColour( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultBgColour" ) ))
        self()->mDefaultBgColour = v;
    }

    /**
      Get Background color
    */
    static
    QColor defaultBgColour()
    {
      return self()->mDefaultBgColour;
    }

    /**
      Get Item object corresponding to DefaultBgColour()
    */
    ItemColor *defaultBgColourItem()
    {
      return mDefaultBgColourItem;
    }

    /**
      Set Message font
    */
    static
    void setMessageFont( const QFont & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "MessageFont" ) ))
        self()->mMessageFont = v;
    }

    /**
      Get Message font
    */
    static
    QFont messageFont()
    {
      return self()->mMessageFont;
    }

    /**
      Get Item object corresponding to MessageFont()
    */
    ItemFont *messageFontItem()
    {
      return mMessageFontItem;
    }

    /**
      Set Run continuously in system tray
    */
    static
    void setRunInSystemTray( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "RunInSystemTray" ) )) {
        self()->mRunInSystemTray = v;
        self()->mSettingsChanged |= signalRunInSystemTrayChanged;
      }
    }

    /**
      Get Run continuously in system tray
    */
    static
    bool runInSystemTray()
    {
      return self()->mRunInSystemTray;
    }

    /**
      Get Item object corresponding to RunInSystemTray()
    */
    ItemBool *runInSystemTrayItem()
    {
      return mRunInSystemTrayItem;
    }

    /**
      Set Disable alarms while not running
    */
    static
    void setDisableAlarmsIfStopped( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DisableAlarmsIfStopped" ) )) {
        self()->mDisableAlarmsIfStopped = v;
        self()->mSettingsChanged |= signalDisableAlarmsIfStoppedChanged;
      }
    }

    /**
      Get Disable alarms while not running
    */
    static
    bool disableAlarmsIfStopped()
    {
      return self()->mDisableAlarmsIfStopped;
    }

    /**
      Get Item object corresponding to DisableAlarmsIfStopped()
    */
    ItemBool *disableAlarmsIfStoppedItem()
    {
      return mDisableAlarmsIfStoppedItem;
    }

    /**
      Set Autostart at login
    */
    static
    void setAutostartTrayIcon( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "AutostartTrayIcon" ) ))
        self()->mAutostartTrayIcon = v;
    }

    /**
      Get Autostart at login
    */
    static
    bool autostartTrayIcon()
    {
      return self()->mAutostartTrayIcon;
    }

    /**
      Get Item object corresponding to AutostartTrayIcon()
    */
    ItemBool *autostartTrayIconItem()
    {
      return mAutostartTrayIconItem;
    }

    /**
      Set Prompt for which resource to store in
    */
    static
    void setAskResource( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "AskResource" ) ))
        self()->mAskResource = v;
    }

    /**
      Get Prompt for which resource to store in
    */
    static
    bool askResource()
    {
      return self()->mAskResource;
    }

    /**
      Get Item object corresponding to AskResource()
    */
    ItemBool *askResourceItem()
    {
      return mAskResourceItem;
    }

    /**
      Set Message windows have a title bar and take keyboard focus
    */
    static
    void setModalMessages( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ModalMessages" ) ))
        self()->mModalMessages = v;
    }

    /**
      Get Message windows have a title bar and take keyboard focus
    */
    static
    bool modalMessages()
    {
      return self()->mModalMessages;
    }

    /**
      Get Item object corresponding to ModalMessages()
    */
    ItemBool *modalMessagesItem()
    {
      return mModalMessagesItem;
    }

    /**
      Set Delay before message window buttons are enabled
    */
    static
    void setMessageButtonDelay( int v )
    {
      if (v < -1)
      {
        kDebug() << "setMessageButtonDelay: value " << v << " is less than the minimum value of -1" << endl;
        v = -1;
      }

      if (v > 10)
      {
        kDebug() << "setMessageButtonDelay: value " << v << " is greater than the maximum value of 10" << endl;
        v = 10;
      }

      if (!self()->isImmutable( QString::fromLatin1 ( "MessageButtonDelay" ) ))
        self()->mMessageButtonDelay = v;
    }

    /**
      Get Delay before message window buttons are enabled
    */
    static
    int messageButtonDelay()
    {
      return self()->mMessageButtonDelay;
    }

    /**
      Get Item object corresponding to MessageButtonDelay()
    */
    ItemInt *messageButtonDelayItem()
    {
      return mMessageButtonDelayItem;
    }

    /**
      Set Show resources
    */
    static
    void setShowResources( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowResources" ) ))
        self()->mShowResources = v;
    }

    /**
      Get Show resources
    */
    static
    bool showResources()
    {
      return self()->mShowResources;
    }

    /**
      Get Item object corresponding to ShowResources()
    */
    ItemBool *showResourcesItem()
    {
      return mShowResourcesItem;
    }

    /**
      Set Show archived alarms
    */
    static
    void setShowArchivedAlarms( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowArchivedAlarms" ) ))
        self()->mShowArchivedAlarms = v;
    }

    /**
      Get Show archived alarms
    */
    static
    bool showArchivedAlarms()
    {
      return self()->mShowArchivedAlarms;
    }

    /**
      Get Item object corresponding to ShowArchivedAlarms()
    */
    ItemBool *showArchivedAlarmsItem()
    {
      return mShowArchivedAlarmsItem;
    }

    /**
      Set Show alarm time
    */
    static
    void setBase_ShowAlarmTime( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_ShowAlarmTime" ) )) {
        self()->mBase_ShowAlarmTime = v;
        self()->mSettingsChanged |= signalShowTimeChanged;
      }
    }

    /**
      Get Show alarm time
    */
    static
    bool base_ShowAlarmTime()
    {
      return self()->mBase_ShowAlarmTime;
    }

    /**
      Get Item object corresponding to Base_ShowAlarmTime()
    */
    ItemBool *base_ShowAlarmTimeItem()
    {
      return mBase_ShowAlarmTimeItem;
    }

    /**
      Set Show time to alarm
    */
    static
    void setShowTimeToAlarm( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowTimeToAlarm" ) )) {
        self()->mShowTimeToAlarm = v;
        self()->mSettingsChanged |= signalShowTimeChanged;
      }
    }

    /**
      Get Show time to alarm
    */
    static
    bool showTimeToAlarm()
    {
      return self()->mShowTimeToAlarm;
    }

    /**
      Get Item object corresponding to ShowTimeToAlarm()
    */
    ItemBool *showTimeToAlarmItem()
    {
      return mShowTimeToAlarmItem;
    }

    /**
      Set Number of alarms to show in system tray tooltip
    */
    static
    void setTooltipAlarmCount( int v )
    {
      if (v < -1)
      {
        kDebug() << "setTooltipAlarmCount: value " << v << " is less than the minimum value of -1" << endl;
        v = -1;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "TooltipAlarmCount" ) ))
        self()->mTooltipAlarmCount = v;
    }

    /**
      Get Number of alarms to show in system tray tooltip
    */
    static
    int tooltipAlarmCount()
    {
      return self()->mTooltipAlarmCount;
    }

    /**
      Get Item object corresponding to TooltipAlarmCount()
    */
    ItemInt *tooltipAlarmCountItem()
    {
      return mTooltipAlarmCountItem;
    }

    /**
      Set Show alarm times in system tray tooltip
    */
    static
    void setShowTooltipAlarmTime( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowTooltipAlarmTime" ) ))
        self()->mShowTooltipAlarmTime = v;
    }

    /**
      Get Show alarm times in system tray tooltip
    */
    static
    bool showTooltipAlarmTime()
    {
      return self()->mShowTooltipAlarmTime;
    }

    /**
      Get Item object corresponding to ShowTooltipAlarmTime()
    */
    ItemBool *showTooltipAlarmTimeItem()
    {
      return mShowTooltipAlarmTimeItem;
    }

    /**
      Set Show time to alarms in system tray tooltip
    */
    static
    void setShowTooltipTimeToAlarm( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowTooltipTimeToAlarm" ) ))
        self()->mShowTooltipTimeToAlarm = v;
    }

    /**
      Get Show time to alarms in system tray tooltip
    */
    static
    bool showTooltipTimeToAlarm()
    {
      return self()->mShowTooltipTimeToAlarm;
    }

    /**
      Get Item object corresponding to ShowTooltipTimeToAlarm()
    */
    ItemBool *showTooltipTimeToAlarmItem()
    {
      return mShowTooltipTimeToAlarmItem;
    }

    /**
      Set Time-to-alarm prefix in system tray tooltip
    */
    static
    void setTooltipTimeToPrefix( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "TooltipTimeToPrefix" ) ))
        self()->mTooltipTimeToPrefix = v;
    }

    /**
      Get Time-to-alarm prefix in system tray tooltip
    */
    static
    QString tooltipTimeToPrefix()
    {
      return self()->mTooltipTimeToPrefix;
    }

    /**
      Get Item object corresponding to TooltipTimeToPrefix()
    */
    ItemString *tooltipTimeToPrefixItem()
    {
      return mTooltipTimeToPrefixItem;
    }

    /**
      Set System tray icon update interval
    */
    static
    void setDaemonTrayCheckInterval( int v )
    {
      if (v < 1)
      {
        kDebug() << "setDaemonTrayCheckInterval: value " << v << " is less than the minimum value of 1" << endl;
        v = 1;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "DaemonTrayCheckInterval" ) )) {
        self()->mDaemonTrayCheckInterval = v;
        self()->mSettingsChanged |= signalDaemonTrayCheckIntervalChanged;
      }
    }

    /**
      Get System tray icon update interval
    */
    static
    int daemonTrayCheckInterval()
    {
      return self()->mDaemonTrayCheckInterval;
    }

    /**
      Get Item object corresponding to DaemonTrayCheckInterval()
    */
    ItemInt *daemonTrayCheckIntervalItem()
    {
      return mDaemonTrayCheckIntervalItem;
    }

    /**
      Set Email client
    */
    static
    void setEmailClient( MailClient v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "EmailClient" ) ))
        self()->mEmailClient = v;
    }

    /**
      Get Email client
    */
    static
    MailClient emailClient()
    {
      return static_cast<MailClient>(self()->mEmailClient);
    }

    /**
      Get Item object corresponding to EmailClient()
    */
    ItemEnum *emailClientItem()
    {
      return mEmailClientItem;
    }

    /**
      Set Whether to copy sent emails into KMail's Sent folder.
    */
    static
    void setBase_EmailCopyToKMail( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_EmailCopyToKMail" ) ))
        self()->mBase_EmailCopyToKMail = v;
    }

    /**
      Get Whether to copy sent emails into KMail's Sent folder.
    */
    static
    bool base_EmailCopyToKMail()
    {
      return self()->mBase_EmailCopyToKMail;
    }

    /**
      Get Item object corresponding to Base_EmailCopyToKMail()
    */
    ItemBool *base_EmailCopyToKMailItem()
    {
      return mBase_EmailCopyToKMailItem;
    }

    /**
      Set 'From' email address
    */
    static
    void setBase_EmailFrom( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_EmailFrom" ) ))
        self()->mBase_EmailFrom = v;
    }

    /**
      Get 'From' email address
    */
    static
    QString base_EmailFrom()
    {
      return self()->mBase_EmailFrom;
    }

    /**
      Get Item object corresponding to Base_EmailFrom()
    */
    ItemString *base_EmailFromItem()
    {
      return mBase_EmailFromItem;
    }

    /**
      Set 'Bcc' email address
    */
    static
    void setBase_EmailBccAddress( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_EmailBccAddress" ) ))
        self()->mBase_EmailBccAddress = v;
    }

    /**
      Get 'Bcc' email address
    */
    static
    QString base_EmailBccAddress()
    {
      return self()->mBase_EmailBccAddress;
    }

    /**
      Get Item object corresponding to Base_EmailBccAddress()
    */
    ItemString *base_EmailBccAddressItem()
    {
      return mBase_EmailBccAddressItem;
    }

    /**
      Set Terminal for command alarms
    */
    static
    void setBase_CmdXTermCommand( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_CmdXTermCommand" ) ))
        self()->mBase_CmdXTermCommand = v;
    }

    /**
      Get Terminal for command alarms
    */
    static
    QString base_CmdXTermCommand()
    {
      return self()->mBase_CmdXTermCommand;
    }

    /**
      Get Item object corresponding to Base_CmdXTermCommand()
    */
    ItemString *base_CmdXTermCommandItem()
    {
      return mBase_CmdXTermCommandItem;
    }

    /**
      Set Start of day for date-only alarms
    */
    static
    void setBase_StartOfDay( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_StartOfDay" ) )) {
        self()->mBase_StartOfDay = v;
        self()->mSettingsChanged |= signalBase_StartOfDayChanged;
      }
    }

    /**
      Get Start of day for date-only alarms
    */
    static
    QDateTime base_StartOfDay()
    {
      return self()->mBase_StartOfDay;
    }

    /**
      Get Item object corresponding to Base_StartOfDay()
    */
    ItemDateTime *base_StartOfDayItem()
    {
      return mBase_StartOfDayItem;
    }

    /**
      Set Start of day validation
    */
    static
    void setSod( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Sod" ) ))
        self()->mSod = v;
    }

    /**
      Get Start of day validation
    */
    static
    int sod()
    {
      return self()->mSod;
    }

    /**
      Get Item object corresponding to Sod()
    */
    ItemInt *sodItem()
    {
      return mSodItem;
    }

    /**
      Set Disabled alarm color
    */
    static
    void setDisabledColour( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DisabledColour" ) )) {
        self()->mDisabledColour = v;
        self()->mSettingsChanged |= signalDisabledColourChanged;
      }
    }

    /**
      Get Disabled alarm color
    */
    static
    QColor disabledColour()
    {
      return self()->mDisabledColour;
    }

    /**
      Get Item object corresponding to DisabledColour()
    */
    ItemColor *disabledColourItem()
    {
      return mDisabledColourItem;
    }

    /**
      Set Archived alarm color
    */
    static
    void setArchivedColour( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ArchivedColour" ) )) {
        self()->mArchivedColour = v;
        self()->mSettingsChanged |= signalArchivedColourChanged;
      }
    }

    /**
      Get Archived alarm color
    */
    static
    QColor archivedColour()
    {
      return self()->mArchivedColour;
    }

    /**
      Get Item object corresponding to ArchivedColour()
    */
    ItemColor *archivedColourItem()
    {
      return mArchivedColourItem;
    }

    /**
      Set Days to keep expired alarms
    */
    static
    void setArchivedKeepDays( int v )
    {
      if (v < -1)
      {
        kDebug() << "setArchivedKeepDays: value " << v << " is less than the minimum value of -1" << endl;
        v = -1;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "ArchivedKeepDays" ) )) {
        self()->mArchivedKeepDays = v;
        self()->mSettingsChanged |= signalArchivedKeepDaysChanged;
      }
    }

    /**
      Get Days to keep expired alarms
    */
    static
    int archivedKeepDays()
    {
      return self()->mArchivedKeepDays;
    }

    /**
      Get Item object corresponding to ArchivedKeepDays()
    */
    ItemInt *archivedKeepDaysItem()
    {
      return mArchivedKeepDaysItem;
    }

    /**
      Set Cancel if late (minutes)
    */
    static
    void setDefaultLateCancel( int v )
    {
      if (v < 0)
      {
        kDebug() << "setDefaultLateCancel: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultLateCancel" ) ))
        self()->mDefaultLateCancel = v;
    }

    /**
      Get Cancel if late (minutes)
    */
    static
    int defaultLateCancel()
    {
      return self()->mDefaultLateCancel;
    }

    /**
      Get Item object corresponding to DefaultLateCancel()
    */
    ItemInt *defaultLateCancelItem()
    {
      return mDefaultLateCancelItem;
    }

    /**
      Set Auto-close window after late-cancellation time
    */
    static
    void setDefaultAutoClose( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultAutoClose" ) ))
        self()->mDefaultAutoClose = v;
    }

    /**
      Get Auto-close window after late-cancellation time
    */
    static
    bool defaultAutoClose()
    {
      return self()->mDefaultAutoClose;
    }

    /**
      Get Item object corresponding to DefaultAutoClose()
    */
    ItemBool *defaultAutoCloseItem()
    {
      return mDefaultAutoCloseItem;
    }

    /**
      Set Confirm acknowledgement
    */
    static
    void setDefaultConfirmAck( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultConfirmAck" ) ))
        self()->mDefaultConfirmAck = v;
    }

    /**
      Get Confirm acknowledgement
    */
    static
    bool defaultConfirmAck()
    {
      return self()->mDefaultConfirmAck;
    }

    /**
      Get Item object corresponding to DefaultConfirmAck()
    */
    ItemBool *defaultConfirmAckItem()
    {
      return mDefaultConfirmAckItem;
    }

    /**
      Set Show in KOrganizer
    */
    static
    void setDefaultCopyToKOrganizer( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultCopyToKOrganizer" ) ))
        self()->mDefaultCopyToKOrganizer = v;
    }

    /**
      Get Show in KOrganizer
    */
    static
    bool defaultCopyToKOrganizer()
    {
      return self()->mDefaultCopyToKOrganizer;
    }

    /**
      Get Item object corresponding to DefaultCopyToKOrganizer()
    */
    ItemBool *defaultCopyToKOrganizerItem()
    {
      return mDefaultCopyToKOrganizerItem;
    }

    /**
      Set Sound
    */
    static
    void setDefaultSoundType( SoundType v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultSoundType" ) ))
        self()->mDefaultSoundType = v;
    }

    /**
      Get Sound
    */
    static
    SoundType defaultSoundType()
    {
      return static_cast<SoundType>(self()->mDefaultSoundType);
    }

    /**
      Get Item object corresponding to DefaultSoundType()
    */
    ItemEnum *defaultSoundTypeItem()
    {
      return mDefaultSoundTypeItem;
    }

    /**
      Set Sound file
    */
    static
    void setDefaultSoundFile( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultSoundFile" ) ))
        self()->mDefaultSoundFile = v;
    }

    /**
      Get Sound file
    */
    static
    QString defaultSoundFile()
    {
      return self()->mDefaultSoundFile;
    }

    /**
      Get Item object corresponding to DefaultSoundFile()
    */
    ItemPath *defaultSoundFileItem()
    {
      return mDefaultSoundFileItem;
    }

    /**
      Set Sound volume
    */
    static
    void setBase_DefaultSoundVolume( int v )
    {
      if (v < -1)
      {
        kDebug() << "setBase_DefaultSoundVolume: value " << v << " is less than the minimum value of -1" << endl;
        v = -1;
      }

      if (v > 100)
      {
        kDebug() << "setBase_DefaultSoundVolume: value " << v << " is greater than the maximum value of 100" << endl;
        v = 100;
      }

      if (!self()->isImmutable( QString::fromLatin1 ( "Base_DefaultSoundVolume" ) ))
        self()->mBase_DefaultSoundVolume = v;
    }

    /**
      Get Sound volume
    */
    static
    int base_DefaultSoundVolume()
    {
      return self()->mBase_DefaultSoundVolume;
    }

    /**
      Get Item object corresponding to Base_DefaultSoundVolume()
    */
    ItemInt *base_DefaultSoundVolumeItem()
    {
      return mBase_DefaultSoundVolumeItem;
    }

    /**
      Set Repeat sound file
    */
    static
    void setDefaultSoundRepeat( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultSoundRepeat" ) ))
        self()->mDefaultSoundRepeat = v;
    }

    /**
      Get Repeat sound file
    */
    static
    bool defaultSoundRepeat()
    {
      return self()->mDefaultSoundRepeat;
    }

    /**
      Get Item object corresponding to DefaultSoundRepeat()
    */
    ItemBool *defaultSoundRepeatItem()
    {
      return mDefaultSoundRepeatItem;
    }

    /**
      Set Enter script
    */
    static
    void setDefaultCmdScript( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultCmdScript" ) ))
        self()->mDefaultCmdScript = v;
    }

    /**
      Get Enter script
    */
    static
    bool defaultCmdScript()
    {
      return self()->mDefaultCmdScript;
    }

    /**
      Get Item object corresponding to DefaultCmdScript()
    */
    ItemBool *defaultCmdScriptItem()
    {
      return mDefaultCmdScriptItem;
    }

    /**
      Set Command output
    */
    static
    void setDefaultCmdLogType( CmdLogType v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultCmdLogType" ) ))
        self()->mDefaultCmdLogType = v;
    }

    /**
      Get Command output
    */
    static
    CmdLogType defaultCmdLogType()
    {
      return static_cast<CmdLogType>(self()->mDefaultCmdLogType);
    }

    /**
      Get Item object corresponding to DefaultCmdLogType()
    */
    ItemEnum *defaultCmdLogTypeItem()
    {
      return mDefaultCmdLogTypeItem;
    }

    /**
      Set Log file
    */
    static
    void setDefaultCmdLogFile( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultCmdLogFile" ) ))
        self()->mDefaultCmdLogFile = v;
    }

    /**
      Get Log file
    */
    static
    QString defaultCmdLogFile()
    {
      return self()->mDefaultCmdLogFile;
    }

    /**
      Get Item object corresponding to DefaultCmdLogFile()
    */
    ItemPath *defaultCmdLogFileItem()
    {
      return mDefaultCmdLogFileItem;
    }

    /**
      Set Copy email to self
    */
    static
    void setDefaultEmailBcc( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultEmailBcc" ) ))
        self()->mDefaultEmailBcc = v;
    }

    /**
      Get Copy email to self
    */
    static
    bool defaultEmailBcc()
    {
      return self()->mDefaultEmailBcc;
    }

    /**
      Get Item object corresponding to DefaultEmailBcc()
    */
    ItemBool *defaultEmailBccItem()
    {
      return mDefaultEmailBccItem;
    }

    /**
      Set Recurrence period
    */
    static
    void setDefaultRecurPeriod( RecurType v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultRecurPeriod" ) ))
        self()->mDefaultRecurPeriod = v;
    }

    /**
      Get Recurrence period
    */
    static
    RecurType defaultRecurPeriod()
    {
      return static_cast<RecurType>(self()->mDefaultRecurPeriod);
    }

    /**
      Get Item object corresponding to DefaultRecurPeriod()
    */
    ItemEnum *defaultRecurPeriodItem()
    {
      return mDefaultRecurPeriodItem;
    }

    /**
      Set In non-leap years, repeat yearly February 29th alarms on:
    */
    static
    void setDefaultFeb29Type( Feb29Type v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultFeb29Type" ) )) {
        self()->mDefaultFeb29Type = v;
        self()->mSettingsChanged |= signalFeb29TypeChanged;
      }
    }

    /**
      Get In non-leap years, repeat yearly February 29th alarms on:
    */
    static
    Feb29Type defaultFeb29Type()
    {
      return static_cast<Feb29Type>(self()->mDefaultFeb29Type);
    }

    /**
      Get Item object corresponding to DefaultFeb29Type()
    */
    ItemEnum *defaultFeb29TypeItem()
    {
      return mDefaultFeb29TypeItem;
    }

    /**
      Set Reminder units
    */
    static
    void setDefaultReminderUnits( TimePeriod::Units v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultReminderUnits" ) ))
        self()->mDefaultReminderUnits = v;
    }

    /**
      Get Reminder units
    */
    static
    TimePeriod::Units defaultReminderUnits()
    {
      return static_cast<TimePeriod::Units>(self()->mDefaultReminderUnits);
    }

    /**
      Get Item object corresponding to DefaultReminderUnits()
    */
    ItemEnum *defaultReminderUnitsItem()
    {
      return mDefaultReminderUnitsItem;
    }

    /**
      Set Pre-alarm action
    */
    static
    void setDefaultPreAction( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultPreAction" ) ))
        self()->mDefaultPreAction = v;
    }

    /**
      Get Pre-alarm action
    */
    static
    QString defaultPreAction()
    {
      return self()->mDefaultPreAction;
    }

    /**
      Get Item object corresponding to DefaultPreAction()
    */
    ItemString *defaultPreActionItem()
    {
      return mDefaultPreActionItem;
    }

    /**
      Set Post-alarm action
    */
    static
    void setDefaultPostAction( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DefaultPostAction" ) ))
        self()->mDefaultPostAction = v;
    }

    /**
      Get Post-alarm action
    */
    static
    QString defaultPostAction()
    {
      return self()->mDefaultPostAction;
    }

    /**
      Get Item object corresponding to DefaultPostAction()
    */
    ItemString *defaultPostActionItem()
    {
      return mDefaultPostActionItem;
    }

    /**
      Set Warn before quitting
    */
    static
    void setBase_QuitWarn( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_QuitWarn" ) ))
        self()->mBase_QuitWarn = v;
    }

    /**
      Get Warn before quitting
    */
    static
    QString base_QuitWarn()
    {
      return self()->mBase_QuitWarn;
    }

    /**
      Get Item object corresponding to Base_QuitWarn()
    */
    ItemString *base_QuitWarnItem()
    {
      return mBase_QuitWarnItem;
    }

    /**
      Set Confirm alarm deletions
    */
    static
    void setBase_ConfirmAlarmDeletion( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_ConfirmAlarmDeletion" ) ))
        self()->mBase_ConfirmAlarmDeletion = v;
    }

    /**
      Get Confirm alarm deletions
    */
    static
    bool base_ConfirmAlarmDeletion()
    {
      return self()->mBase_ConfirmAlarmDeletion;
    }

    /**
      Get Item object corresponding to Base_ConfirmAlarmDeletion()
    */
    ItemBool *base_ConfirmAlarmDeletionItem()
    {
      return mBase_ConfirmAlarmDeletionItem;
    }

    /**
      Set Notify when remote emails are queued
    */
    static
    void setBase_EmailQueuedNotify( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Base_EmailQueuedNotify" ) ))
        self()->mBase_EmailQueuedNotify = v;
    }

    /**
      Get Notify when remote emails are queued
    */
    static
    bool base_EmailQueuedNotify()
    {
      return self()->mBase_EmailQueuedNotify;
    }

    /**
      Get Item object corresponding to Base_EmailQueuedNotify()
    */
    ItemBool *base_EmailQueuedNotifyItem()
    {
      return mBase_EmailQueuedNotifyItem;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }

  Q_SIGNALS:
    void runInSystemTrayChanged(bool RunInSystemTray);

    void disableAlarmsIfStoppedChanged(bool DisableAlarmsIfStopped);

    void base_StartOfDayChanged(const QDateTime & Base_StartOfDay);

    void showTimeChanged(bool Base_ShowAlarmTime, bool ShowTimeToAlarm);

    void daemonTrayCheckIntervalChanged(int DaemonTrayCheckInterval);

    void disabledColourChanged(const QColor & DisabledColour);

    void archivedColourChanged(const QColor & ArchivedColour);

    void archivedKeepDaysChanged(int ArchivedKeepDays);

    void feb29TypeChanged(Feb29Type DefaultFeb29Type);

  protected:
    PreferencesBase();
    static PreferencesBase *mSelf;

    virtual void usrWriteConfig();
  protected:

    // General
    QString mVersion;
    QString mBase_TimeZone;
    QStringList mBase_MessageColours;
    QColor mDefaultBgColour;
    QFont mMessageFont;
    bool mRunInSystemTray;
    bool mDisableAlarmsIfStopped;
    bool mAutostartTrayIcon;
    bool mAskResource;
    bool mModalMessages;
    int mMessageButtonDelay;
    bool mShowResources;
    bool mShowArchivedAlarms;
    bool mBase_ShowAlarmTime;
    bool mShowTimeToAlarm;
    int mTooltipAlarmCount;
    bool mShowTooltipAlarmTime;
    bool mShowTooltipTimeToAlarm;
    QString mTooltipTimeToPrefix;
    int mDaemonTrayCheckInterval;
    int mEmailClient;
    bool mBase_EmailCopyToKMail;
    QString mBase_EmailFrom;
    QString mBase_EmailBccAddress;
    QString mBase_CmdXTermCommand;
    QDateTime mBase_StartOfDay;
    int mSod;
    QColor mDisabledColour;
    QColor mArchivedColour;
    int mArchivedKeepDays;

    // Defaults
    int mDefaultLateCancel;
    bool mDefaultAutoClose;
    bool mDefaultConfirmAck;
    bool mDefaultCopyToKOrganizer;
    int mDefaultSoundType;
    QString mDefaultSoundFile;
    int mBase_DefaultSoundVolume;
    bool mDefaultSoundRepeat;
    bool mDefaultCmdScript;
    int mDefaultCmdLogType;
    QString mDefaultCmdLogFile;
    bool mDefaultEmailBcc;
    int mDefaultRecurPeriod;
    int mDefaultFeb29Type;
    int mDefaultReminderUnits;
    QString mDefaultPreAction;
    QString mDefaultPostAction;

    // Notification Messages
    QString mBase_QuitWarn;
    bool mBase_ConfirmAlarmDeletion;
    bool mBase_EmailQueuedNotify;

  private:
    ItemString *mVersionItem;
    ItemString *mBase_TimeZoneItem;
    ItemStringList *mBase_MessageColoursItem;
    ItemColor *mDefaultBgColourItem;
    ItemFont *mMessageFontItem;
    ItemBool *mRunInSystemTrayItem;
    ItemBool *mDisableAlarmsIfStoppedItem;
    ItemBool *mAutostartTrayIconItem;
    ItemBool *mAskResourceItem;
    ItemBool *mModalMessagesItem;
    ItemInt *mMessageButtonDelayItem;
    ItemBool *mShowResourcesItem;
    ItemBool *mShowArchivedAlarmsItem;
    ItemBool *mBase_ShowAlarmTimeItem;
    ItemBool *mShowTimeToAlarmItem;
    ItemInt *mTooltipAlarmCountItem;
    ItemBool *mShowTooltipAlarmTimeItem;
    ItemBool *mShowTooltipTimeToAlarmItem;
    ItemString *mTooltipTimeToPrefixItem;
    ItemInt *mDaemonTrayCheckIntervalItem;
    ItemEnum *mEmailClientItem;
    ItemBool *mBase_EmailCopyToKMailItem;
    ItemString *mBase_EmailFromItem;
    ItemString *mBase_EmailBccAddressItem;
    ItemString *mBase_CmdXTermCommandItem;
    ItemDateTime *mBase_StartOfDayItem;
    ItemInt *mSodItem;
    ItemColor *mDisabledColourItem;
    ItemColor *mArchivedColourItem;
    ItemInt *mArchivedKeepDaysItem;
    ItemInt *mDefaultLateCancelItem;
    ItemBool *mDefaultAutoCloseItem;
    ItemBool *mDefaultConfirmAckItem;
    ItemBool *mDefaultCopyToKOrganizerItem;
    ItemEnum *mDefaultSoundTypeItem;
    ItemPath *mDefaultSoundFileItem;
    ItemInt *mBase_DefaultSoundVolumeItem;
    ItemBool *mDefaultSoundRepeatItem;
    ItemBool *mDefaultCmdScriptItem;
    ItemEnum *mDefaultCmdLogTypeItem;
    ItemPath *mDefaultCmdLogFileItem;
    ItemBool *mDefaultEmailBccItem;
    ItemEnum *mDefaultRecurPeriodItem;
    ItemEnum *mDefaultFeb29TypeItem;
    ItemEnum *mDefaultReminderUnitsItem;
    ItemString *mDefaultPreActionItem;
    ItemString *mDefaultPostActionItem;
    ItemString *mBase_QuitWarnItem;
    ItemBool *mBase_ConfirmAlarmDeletionItem;
    ItemBool *mBase_EmailQueuedNotifyItem;
    uint mSettingsChanged;
};

#endif

