#include <kdialog.h>
#include <klocale.h>

#ifndef UI_CERTIFICATEWIZARD_H
#define UI_CERTIFICATEWIZARD_H

#include <qvariant.h>


#include <Qt3Support/Q3ButtonGroup>
#include <Qt3Support/Q3Frame>
#include <Qt3Support/Q3GroupBox>
#include <Qt3Support/Q3TextEdit>
#include <Qt3Support/Q3Wizard>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QComboBox>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>
#include "klineedit.h"
#include "kpushbutton.h"
#include <kurlrequester.h>
#include <Qt3Support/Q3MimeSourceFactory>

class Ui_CertificateWizard
{
public:
    QWidget *introPage;
    QVBoxLayout *vboxLayout;
    QLabel *TextLabel1;
    QSpacerItem *spacerItem;
    QWidget *WizardPage;
    QVBoxLayout *vboxLayout1;
    QLabel *TextLabel2_2;
    QSpacerItem *spacerItem1;
    Q3GroupBox *groupBox1;
    QHBoxLayout *hboxLayout;
    QLabel *textLabel1;
    QComboBox *keyLengthCB;
    QSpacerItem *spacerItem2;
    Q3ButtonGroup *certTypeBG;
    QVBoxLayout *vboxLayout2;
    QRadioButton *signOnlyCB;
    QRadioButton *encryptOnlyCB;
    QRadioButton *bothCB;
    QSpacerItem *spacerItem3;
    QWidget *personalDataPage;
    QGridLayout *gridLayout;
    QLabel *TextLabel2;
    QSpacerItem *spacerItem4;
    QPushButton *insertAddressButton;
    QSpacerItem *spacerItem5;
    Q3Frame *edContainer;
    QWidget *generatePage;
    QGridLayout *gridLayout1;
    QLabel *TextLabel4;
    QSpacerItem *spacerItem6;
    Q3ButtonGroup *ButtonGroup7;
    QGridLayout *gridLayout2;
    KUrlRequester *storeUR;
    QRadioButton *storeInFileRB;
    QRadioButton *sendToCARB;
    QLineEdit *caEmailED;
    QCheckBox *brokenCA;
    QPushButton *generatePB;
    QSpacerItem *spacerItem7;
    QSpacerItem *spacerItem8;
    QWidget *finishPage;
    QVBoxLayout *vboxLayout3;
    QLabel *TextLabel7;
    Q3TextEdit *certificateTE;

    void setupUi(Q3Wizard *CertificateWizard)
    {
    CertificateWizard->setObjectName(QString::fromUtf8("CertificateWizard"));
    QFont font;
    font.setPointSize(16);
    font.setBold(false);
    CertificateWizard->setTitleFont(font);
    introPage = new QWidget(CertificateWizard);
    introPage->setObjectName(QString::fromUtf8("introPage"));
    vboxLayout = new QVBoxLayout(introPage);
    vboxLayout->setSpacing(6);
    vboxLayout->setMargin(0);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    TextLabel1 = new QLabel(introPage);
    TextLabel1->setObjectName(QString::fromUtf8("TextLabel1"));
    TextLabel1->setWordWrap(true);

    vboxLayout->addWidget(TextLabel1);

    spacerItem = new QSpacerItem(20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding);

    vboxLayout->addItem(spacerItem);

    CertificateWizard->addPage(introPage, tr2i18n("Key Generation Wizard", 0));
    WizardPage = new QWidget(CertificateWizard);
    WizardPage->setObjectName(QString::fromUtf8("WizardPage"));
    vboxLayout1 = new QVBoxLayout(WizardPage);
    vboxLayout1->setSpacing(6);
    vboxLayout1->setMargin(0);
    vboxLayout1->setObjectName(QString::fromUtf8("vboxLayout1"));
    TextLabel2_2 = new QLabel(WizardPage);
    TextLabel2_2->setObjectName(QString::fromUtf8("TextLabel2_2"));
    TextLabel2_2->setAlignment(Qt::AlignVCenter);

    vboxLayout1->addWidget(TextLabel2_2);

    spacerItem1 = new QSpacerItem(20, 31, QSizePolicy::Minimum, QSizePolicy::Expanding);

    vboxLayout1->addItem(spacerItem1);

    groupBox1 = new Q3GroupBox(WizardPage);
    groupBox1->setObjectName(QString::fromUtf8("groupBox1"));
    groupBox1->setColumnLayout(0, Qt::Vertical);
    groupBox1->layout()->setSpacing(6);
    groupBox1->layout()->setMargin(0);
    hboxLayout = new QHBoxLayout(groupBox1->layout());
    hboxLayout->setAlignment(Qt::AlignTop);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    textLabel1 = new QLabel(groupBox1);
    textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
    textLabel1->setWordWrap(false);

    hboxLayout->addWidget(textLabel1);

    keyLengthCB = new QComboBox(groupBox1);
    keyLengthCB->setObjectName(QString::fromUtf8("keyLengthCB"));

    hboxLayout->addWidget(keyLengthCB);

    spacerItem2 = new QSpacerItem(61, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout->addItem(spacerItem2);


    vboxLayout1->addWidget(groupBox1);

    certTypeBG = new Q3ButtonGroup(WizardPage);
    certTypeBG->setObjectName(QString::fromUtf8("certTypeBG"));
    certTypeBG->setColumnLayout(0, Qt::Vertical);
    certTypeBG->layout()->setSpacing(6);
    certTypeBG->layout()->setMargin(0);
    vboxLayout2 = new QVBoxLayout(certTypeBG->layout());
    vboxLayout2->setAlignment(Qt::AlignTop);
    vboxLayout2->setObjectName(QString::fromUtf8("vboxLayout2"));
    signOnlyCB = new QRadioButton(certTypeBG);
    signOnlyCB->setObjectName(QString::fromUtf8("signOnlyCB"));

    vboxLayout2->addWidget(signOnlyCB);

    encryptOnlyCB = new QRadioButton(certTypeBG);
    encryptOnlyCB->setObjectName(QString::fromUtf8("encryptOnlyCB"));

    vboxLayout2->addWidget(encryptOnlyCB);

    bothCB = new QRadioButton(certTypeBG);
    bothCB->setObjectName(QString::fromUtf8("bothCB"));
    bothCB->setChecked(true);

    vboxLayout2->addWidget(bothCB);


    vboxLayout1->addWidget(certTypeBG);

    spacerItem3 = new QSpacerItem(21, 60, QSizePolicy::Minimum, QSizePolicy::Expanding);

    vboxLayout1->addItem(spacerItem3);

    CertificateWizard->addPage(WizardPage, tr2i18n("Key Parameters", 0));
    personalDataPage = new QWidget(CertificateWizard);
    personalDataPage->setObjectName(QString::fromUtf8("personalDataPage"));
    gridLayout = new QGridLayout(personalDataPage);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(0);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    TextLabel2 = new QLabel(personalDataPage);
    TextLabel2->setObjectName(QString::fromUtf8("TextLabel2"));
    TextLabel2->setAlignment(Qt::AlignVCenter);
    TextLabel2->setWordWrap(true);

    gridLayout->addWidget(TextLabel2, 0, 0, 1, 2);

    spacerItem4 = new QSpacerItem(440, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    gridLayout->addItem(spacerItem4, 4, 0, 1, 1);

    insertAddressButton = new QPushButton(personalDataPage);
    insertAddressButton->setObjectName(QString::fromUtf8("insertAddressButton"));

    gridLayout->addWidget(insertAddressButton, 4, 1, 1, 1);

    spacerItem5 = new QSpacerItem(20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding);

    gridLayout->addItem(spacerItem5, 1, 0, 1, 1);

    edContainer = new Q3Frame(personalDataPage);
    edContainer->setObjectName(QString::fromUtf8("edContainer"));
    QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(3), static_cast<QSizePolicy::Policy>(5));
    sizePolicy.setHorizontalStretch(0);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(edContainer->sizePolicy().hasHeightForWidth());
    edContainer->setSizePolicy(sizePolicy);
    edContainer->setFrameShape(Q3Frame::StyledPanel);
    edContainer->setFrameShadow(Q3Frame::Sunken);

    gridLayout->addWidget(edContainer, 2, 0, 1, 2);

    CertificateWizard->addPage(personalDataPage, tr2i18n("Your Personal Data", 0));
    generatePage = new QWidget(CertificateWizard);
    generatePage->setObjectName(QString::fromUtf8("generatePage"));
    gridLayout1 = new QGridLayout(generatePage);
    gridLayout1->setSpacing(6);
    gridLayout1->setMargin(0);
    gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
    TextLabel4 = new QLabel(generatePage);
    TextLabel4->setObjectName(QString::fromUtf8("TextLabel4"));
    TextLabel4->setAlignment(Qt::AlignVCenter);
    TextLabel4->setWordWrap(true);

    gridLayout1->addWidget(TextLabel4, 0, 0, 1, 3);

    spacerItem6 = new QSpacerItem(21, 31, QSizePolicy::Minimum, QSizePolicy::Expanding);

    gridLayout1->addItem(spacerItem6, 1, 0, 1, 2);

    ButtonGroup7 = new Q3ButtonGroup(generatePage);
    ButtonGroup7->setObjectName(QString::fromUtf8("ButtonGroup7"));
    QSizePolicy sizePolicy1(static_cast<QSizePolicy::Policy>(5), static_cast<QSizePolicy::Policy>(1));
    sizePolicy1.setHorizontalStretch(0);
    sizePolicy1.setVerticalStretch(0);
    sizePolicy1.setHeightForWidth(ButtonGroup7->sizePolicy().hasHeightForWidth());
    ButtonGroup7->setSizePolicy(sizePolicy1);
    ButtonGroup7->setColumnLayout(0, Qt::Vertical);
    ButtonGroup7->layout()->setSpacing(6);
    ButtonGroup7->layout()->setMargin(11);
    gridLayout2 = new QGridLayout(ButtonGroup7->layout());
    gridLayout2->setAlignment(Qt::AlignTop);
    gridLayout2->setObjectName(QString::fromUtf8("gridLayout2"));
    storeUR = new KUrlRequester(ButtonGroup7);
    storeUR->setObjectName(QString::fromUtf8("storeUR"));

    gridLayout2->addWidget(storeUR, 0, 1, 1, 1);

    storeInFileRB = new QRadioButton(ButtonGroup7);
    storeInFileRB->setObjectName(QString::fromUtf8("storeInFileRB"));

    gridLayout2->addWidget(storeInFileRB, 0, 0, 1, 1);

    sendToCARB = new QRadioButton(ButtonGroup7);
    sendToCARB->setObjectName(QString::fromUtf8("sendToCARB"));
    sendToCARB->setChecked(true);

    gridLayout2->addWidget(sendToCARB, 1, 0, 1, 1);

    caEmailED = new QLineEdit(ButtonGroup7);
    caEmailED->setObjectName(QString::fromUtf8("caEmailED"));

    gridLayout2->addWidget(caEmailED, 1, 1, 1, 1);

    brokenCA = new QCheckBox(ButtonGroup7);
    brokenCA->setObjectName(QString::fromUtf8("brokenCA"));

    gridLayout2->addWidget(brokenCA, 2, 0, 1, 2);


    gridLayout1->addWidget(ButtonGroup7, 2, 0, 1, 3);

    generatePB = new QPushButton(generatePage);
    generatePB->setObjectName(QString::fromUtf8("generatePB"));
    generatePB->setMinimumSize(QSize(0, 30));

    gridLayout1->addWidget(generatePB, 3, 1, 1, 1);

    spacerItem7 = new QSpacerItem(118, 16, QSizePolicy::Expanding, QSizePolicy::Minimum);

    gridLayout1->addItem(spacerItem7, 3, 2, 1, 1);

    spacerItem8 = new QSpacerItem(119, 16, QSizePolicy::Expanding, QSizePolicy::Minimum);

    gridLayout1->addItem(spacerItem8, 3, 0, 1, 1);

    CertificateWizard->addPage(generatePage, tr2i18n("Decentralized Key Generation", 0));
    finishPage = new QWidget(CertificateWizard);
    finishPage->setObjectName(QString::fromUtf8("finishPage"));
    vboxLayout3 = new QVBoxLayout(finishPage);
    vboxLayout3->setSpacing(6);
    vboxLayout3->setMargin(11);
    vboxLayout3->setObjectName(QString::fromUtf8("vboxLayout3"));
    TextLabel7 = new QLabel(finishPage);
    TextLabel7->setObjectName(QString::fromUtf8("TextLabel7"));
    TextLabel7->setAlignment(Qt::AlignVCenter);
    TextLabel7->setWordWrap(true);

    vboxLayout3->addWidget(TextLabel7);

    certificateTE = new Q3TextEdit(finishPage);
    certificateTE->setObjectName(QString::fromUtf8("certificateTE"));
    certificateTE->setReadOnly(true);

    vboxLayout3->addWidget(certificateTE);

    CertificateWizard->addPage(finishPage, tr2i18n("Your Certificate Request is Ready to Be Sent", 0));
    textLabel1->setBuddy(keyLengthCB);
    QWidget::setTabOrder(sendToCARB, caEmailED);
    QWidget::setTabOrder(caEmailED, certificateTE);
    QWidget::setTabOrder(certificateTE, generatePB);

    retranslateUi(CertificateWizard);

    QSize size(832, 589);
    size = size.expandedTo(CertificateWizard->minimumSizeHint());
    CertificateWizard->resize(size);

    QObject::connect(generatePB, SIGNAL(clicked()), CertificateWizard, SLOT(slotGenerateCertificate()));
    QObject::connect(sendToCARB, SIGNAL(toggled(bool)), caEmailED, SLOT(setEnabled(bool)));
    QObject::connect(storeInFileRB, SIGNAL(toggled(bool)), storeUR, SLOT(setEnabled(bool)));
    QObject::connect(caEmailED, SIGNAL(textChanged(QString)), CertificateWizard, SLOT(slotEmailAddressChanged(QString)));
    QObject::connect(sendToCARB, SIGNAL(clicked()), caEmailED, SLOT(setFocus()));
    QObject::connect(storeInFileRB, SIGNAL(clicked()), storeUR, SLOT(setFocus()));

    QMetaObject::connectSlotsByName(CertificateWizard);
    } // setupUi

    void retranslateUi(Q3Wizard *CertificateWizard)
    {
    CertificateWizard->setWindowTitle(tr2i18n("Key Generation Wizard", 0));
    TextLabel1->setText(tr2i18n("<b>Welcome to the Key Generation Wizard.</b>\n"
"<br>\n"
"<br>\n"
"In a few easy steps, this wizard will help you to create a new key pair and request a certificate for it. You can then use your certificate in order to sign messages, to encrypt messages and to decrypt messages that other people send to you in encrypted form.\n"
"<p>\n"
"The key pair will be generated in a decentralized manner. Please contact your local help desk if you are unsure how to obtain a certificate for your new key in your organization.", 0));
    CertificateWizard->setTitle(introPage, tr2i18n("Key Generation Wizard", 0));
    TextLabel2_2->setText(tr2i18n("On this page, you will configure the cryptographic key length and the type of certificate to create.", 0));
    groupBox1->setTitle(tr2i18n("Cryptographic Key Length", 0));
    textLabel1->setText(tr2i18n("Choose &key length:", 0));
    certTypeBG->setTitle(tr2i18n("Certificate Usage", 0));
    signOnlyCB->setText(tr2i18n("For &signing only", 0));
    encryptOnlyCB->setText(tr2i18n("For &encrypting only", 0));
    bothCB->setText(tr2i18n("For signing &and encrypting", 0));
    CertificateWizard->setTitle(WizardPage, tr2i18n("Key Parameters", 0));
    TextLabel2->setText(tr2i18n("On this page, you will enter some personal data that will be stored in your certificate and that will help other people to determine that it is actually you who is sending a message.", 0));
    insertAddressButton->setText(tr2i18n("&Insert My Address", 0));
    insertAddressButton->setProperty("toolTip", QVariant(tr2i18n("This will insert your address if you have set the \"Who am I\" information in the address book", 0)));
    CertificateWizard->setTitle(personalDataPage, tr2i18n("Your Personal Data", 0));
    TextLabel4->setText(tr2i18n("<qt><p>On this page, you will create a key pair in a decentralized way.\n"
"</p><p>You can either store the certificate request in a file for later transmission or \n"
"send it to the Certificate Authority (CA) directly. Please check with \n"
"your local help desk if you are unsure what to select here.</p><p>\n"
"Once you are done with your settings, click \n"
"<em>Generate Key Pair and Certificate Request</em> in order to generate your key pair and a corresponding certificate request.</p>\n"
"<p><b>Note:</b> if you choose to send via email directly, \n"
"a kmail composer will be opened; you can add detailed information for the CA\n"
"there.</p><qt>", 0));
    ButtonGroup7->setTitle(tr2i18n("Certificate Request Options", 0));
    storeInFileRB->setText(tr2i18n("&Store in a file:", 0));
    sendToCARB->setText(tr2i18n("Send to CA as an &email message:", 0));
    brokenCA->setText(tr2i18n("Add email to DN in request for broken CAs", 0));
    generatePB->setText(tr2i18n("&Generate Key Pair && Certificate Request", 0));
    CertificateWizard->setTitle(generatePage, tr2i18n("Decentralized Key Generation", 0));
    TextLabel7->setText(tr2i18n("<qt>\n"
"Your key pair has now been created and stored locally. The corresponding certificate request is now ready to be sent to the CA (certification authority) which will generate a certificate for you and send it back via email (unless you have selected storage in a file). Please review the certificate details shown below.\n"
"<p>\n"
"If you want to change anything, press Back and make your changes; otherwise, press Finish to send the certificate request to the CA.\n"
"</qt>", 0));
    CertificateWizard->setTitle(finishPage, tr2i18n("Your Certificate Request is Ready to Be Sent", 0));
    Q_UNUSED(CertificateWizard);
    } // retranslateUi

};

namespace Ui {
    class CertificateWizard: public Ui_CertificateWizard {};
} // namespace Ui

class CertificateWizard : public Q3Wizard, public Ui::CertificateWizard
{
    Q_OBJECT

public:
    CertificateWizard(QWidget* parent = 0, const char* name = 0);
    ~CertificateWizard();

protected slots:
    virtual void languageChange();

    virtual void slotEmailAddressChanged(const QString&);
    virtual void slotGenerateCertificate();


};

#endif // CERTIFICATEWIZARD_H

